=== modified file 'DBUS-API'
--- DBUS-API	2012-01-15 20:27:28 +0000
+++ DBUS-API	2014-08-10 14:13:02 +0000
@@ -150,9 +150,6 @@
     milliseconds, depending on ApprovedByDefault.  Approve() can now
     usefully be called on this client object.
     
-*** PropertyChanged(s: Property, v: Value)
-    The Property on this client has changed to Value.
-    
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 

=== modified file 'Makefile'
--- Makefile	2014-07-17 03:24:57 +0000
+++ Makefile	2014-10-05 20:08:58 +0000
@@ -26,7 +26,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.7
+version=1.6.9
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== modified file 'NEWS'
--- NEWS	2014-07-17 03:24:57 +0000
+++ NEWS	2014-10-05 20:08:58 +0000
@@ -1,6 +1,18 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.6.9 (2014-10-05)
+* Server
+** Changed to emit standard D-Bus signal when D-Bus properties change.
+   (The old signal is still emitted too, but marked as deprecated.)
+
+Version 1.6.8 (2014-08-06)
+* Client
+** Bug fix: mandos-keygen now generates working SSH checker commands.
+* Server
+** Bug fix: "mandos-monitor" now really redraws screen on Ctrl-L.
+** Now requires Python 2.7.
+
 Version 1.6.7 (2014-07-17)
 * Client
 ** Bug fix: Now compatible with GPGME 1.5.0.

=== modified file 'TODO'
--- TODO	2014-07-14 21:41:08 +0000
+++ TODO	2015-05-22 20:23:46 +0000
@@ -20,9 +20,12 @@
 * mandos-applet
 
 * mandos-client
+** TODO [#A] --dh-params=FILE
 ** TODO [#B] Use capabilities instead of seteuid().
+   https://forums.grsecurity.net/viewtopic.php?f=7&t=2522
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
 ** TODO [#C] Make start_mandos_communication() take "struct server".
+** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -32,7 +35,6 @@
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
 * askpass-fifo
-** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
 ** TODO [#B] lock stdin (with flock()?)
@@ -48,6 +50,12 @@
 ** kernel command line option for debug info
 
 * mandos (server)
+** TODO [#B] Work around Avahi issue
+   Avahi does not announce link-local addresses if any global
+   addresses exist: http://lists.freedesktop.org/archives/avahi/2010-March/001863.html
+** TODO [#B] --notify-command
+   This would allow the mandos.service to use
+   --notify-command="systemd-notify --pid READY=1"
 ** TODO [#B] Log level							  :BUGS:
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
@@ -69,9 +77,6 @@
 ** TODO Use python-tlslite?
 ** TODO D-Bus AddClient() method on server object
 ** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
-** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal	  :2:
-   TODO Deprecate se.recompile.Mandos.Client.PropertyChanged - annotate!
-   TODO Can use "invalidates" annotation to also emit on changed secret.
 ** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object :2:
    Deprecate methods GetAllClients(), GetAllClientsWithProperties()
    and signals ClientAdded and ClientRemoved.
@@ -80,12 +85,14 @@
 ** TODO Secret Service API?
    http://standards.freedesktop.org/secret-service/
 ** TODO Remove D-Bus interfaces with old domain name			  :2:
-** TODO Remove old string_to_delta format				  :2:
+** TODO Remove old string_to_delta format				     :2:
 ** TODO http://0pointer.de/blog/projects/stateless.html
 *** tmpfiles snippet to create /var/lib/mandos with right user+perms
 *** File in /usr/lib/sysusers.d to create user+group "_mandos"
 ** TODO Error handling on error parsing config files
 ** TODO init.d script error handling
+** TODO D-Bus server properties; address, port, interface, etc.		     :2:
+** TODO [#C] In Python 3.3, use shlex.quote() instead of re.escape()
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -93,7 +100,7 @@
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Remove old string_to_delta format				  :2:
+** TODO Remove old string_to_delta format				     :2:
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'common.ent'
--- common.ent	2014-07-17 03:24:57 +0000
+++ common.ent	2014-10-05 20:08:58 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.7">
+<!ENTITY version "1.6.9">

=== modified file 'debian/changelog'
--- debian/changelog	2014-07-17 03:24:57 +0000
+++ debian/changelog	2014-10-05 20:08:58 +0000
@@ -1,3 +1,25 @@
+mandos (1.6.9-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/control (Build-Depends): Fix "still uses GnutLS 2.x" by
+    changing from "libgnutls-dev" to "libgnutls28-dev | gnutls-dev"
+    (Closes: #762349)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 05 Oct 2014 22:05:06 +0200
+
+mandos (1.6.8-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/control (Source: mandos/Build-Depends-Indep): Since upstream
+    now requires Python 2.7, depend on exactly the python2.7 package and
+    all the Python 2.7 versions of the python modules.
+    (Package: mandos/Depends): - '' - but still depend on python (>=2.7)
+    and the generic versions of the Python modules; this is for mandos-ctl
+    and mandos-monitor, both of which are compatible with Python 3, and
+    use #!/usr/bin/python.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Wed, 06 Aug 2014 22:55:24 +0200
+
 mandos (1.6.7-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2014-07-25 22:44:20 +0000
+++ debian/control	2014-10-08 21:03:05 +0000
@@ -5,18 +5,18 @@
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config
+	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev
+	| gnutls-dev, xsltproc, pkg-config
 Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
 	python2.7-dbus, python2.7-avahi, python2.7-gobject
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (<= 2.7), python2.7, python-gnutls,
+Depends: ${misc:Depends}, python (>= 2.7), python2.7, python-gnutls,
 	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
 	python2.7-avahi, python-gobject, python2.7-gobject,
 	avahi-daemon, adduser, python-urwid, python2.7-urwid,

=== modified file 'intro.xml'
--- intro.xml	2014-06-22 02:19:30 +0000
+++ intro.xml	2015-03-10 18:03:38 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2015-03-08">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -197,6 +197,16 @@
       </para>
     </refsect2>
     
+    <refsect2 id="sniff">
+      <title>How about sniffing the network traffic and decrypting it
+      later by physically grabbing the Mandos client and using its
+      key?</title>
+      <para>
+	We only use <acronym>PFS</acronym> (Perfect Forward Security)
+	key exchange algorithms in TLS, which protects against this.
+      </para>
+    </refsect2>
+    
     <refsect2 id="physgrab">
       <title>Physically grabbing the Mandos server computer?</title>
       <para>

=== modified file 'mandos'
--- mandos	2014-07-25 23:39:49 +0000
+++ mandos	2015-04-03 03:01:02 +0000
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2015 Teddy Hogeborn
+# Copyright © 2008-2015 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -88,26 +88,27 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.6.7"
+if sys.version_info.major == 2:
+    str = unicode
+
+version = "1.6.9"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
 syslogger = None
 
 try:
-    if_nametoindex = (ctypes.cdll.LoadLibrary
-                      (ctypes.util.find_library("c"))
-                      .if_nametoindex)
+    if_nametoindex = ctypes.cdll.LoadLibrary(
+        ctypes.util.find_library("c")).if_nametoindex
 except (OSError, AttributeError):
+    
     def if_nametoindex(interface):
         "Get an interface index the hard way, i.e. using fcntl()"
         SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
         with contextlib.closing(socket.socket()) as s:
             ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                struct.pack(str("16s16x"),
-                                            interface))
-        interface_index = struct.unpack(str("I"),
-                                        ifreq[16:20])[0]
+                                struct.pack(b"16s16x", interface))
+        interface_index = struct.unpack("I", ifreq[16:20])[0]
         return interface_index
 
 
@@ -115,10 +116,9 @@
     """init logger and add loglevel"""
     
     global syslogger
-    syslogger = (logging.handlers.SysLogHandler
-                 (facility =
-                  logging.handlers.SysLogHandler.LOG_DAEMON,
-                  address = str("/dev/log")))
+    syslogger = (logging.handlers.SysLogHandler(
+        facility = logging.handlers.SysLogHandler.LOG_DAEMON,
+        address = "/dev/log"))
     syslogger.setFormatter(logging.Formatter
                            ('Mandos [%(process)d]: %(levelname)s:'
                             ' %(message)s'))
@@ -141,6 +141,7 @@
 
 class PGPEngine(object):
     """A simple class for OpenPGP symmetric encryption & decryption"""
+    
     def __init__(self):
         self.tempdir = tempfile.mkdtemp(prefix="mandos-")
         self.gnupgargs = ['--batch',
@@ -185,8 +186,8 @@
     
     def encrypt(self, data, password):
         passphrase = self.password_encode(password)
-        with tempfile.NamedTemporaryFile(dir=self.tempdir
-                                         ) as passfile:
+        with tempfile.NamedTemporaryFile(
+                dir=self.tempdir) as passfile:
             passfile.write(passphrase)
             passfile.flush()
             proc = subprocess.Popen(['gpg', '--symmetric',
@@ -203,8 +204,8 @@
     
     def decrypt(self, data, password):
         passphrase = self.password_encode(password)
-        with tempfile.NamedTemporaryFile(dir = self.tempdir
-                                         ) as passfile:
+        with tempfile.NamedTemporaryFile(
+                dir = self.tempdir) as passfile:
             passfile.write(passphrase)
             passfile.flush()
             proc = subprocess.Popen(['gpg', '--decrypt',
@@ -214,8 +215,7 @@
                                     stdin = subprocess.PIPE,
                                     stdout = subprocess.PIPE,
                                     stderr = subprocess.PIPE)
-            decrypted_plaintext, err = proc.communicate(input
-                                                        = data)
+            decrypted_plaintext, err = proc.communicate(input = data)
         if proc.returncode != 0:
             raise PGPError(err)
         return decrypted_plaintext
@@ -224,13 +224,14 @@
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
-        super(AvahiError, self).__init__(value, *args, **kwargs)
-    def __unicode__(self):
-        return unicode(repr(self.value))
+        return super(AvahiError, self).__init__(value, *args,
+                                                **kwargs)
+
 
 class AvahiServiceError(AvahiError):
     pass
 
+
 class AvahiGroupError(AvahiError):
     pass
 
@@ -256,10 +257,17 @@
     bus: dbus.SystemBus()
     """
     
-    def __init__(self, interface = avahi.IF_UNSPEC, name = None,
-                 servicetype = None, port = None, TXT = None,
-                 domain = "", host = "", max_renames = 32768,
-                 protocol = avahi.PROTO_UNSPEC, bus = None):
+    def __init__(self,
+                 interface = avahi.IF_UNSPEC,
+                 name = None,
+                 servicetype = None,
+                 port = None,
+                 TXT = None,
+                 domain = "",
+                 host = "",
+                 max_renames = 32768,
+                 protocol = avahi.PROTO_UNSPEC,
+                 bus = None):
         self.interface = interface
         self.name = name
         self.type = servicetype
@@ -275,25 +283,31 @@
         self.bus = bus
         self.entry_group_state_changed_match = None
     
-    def rename(self):
+    def rename(self, remove=True):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
             logger.critical("No suitable Zeroconf service name found"
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = unicode(self.server
-                            .GetAlternativeServiceName(self.name))
+        self.name = str(
+            self.server.GetAlternativeServiceName(self.name))
+        self.rename_count += 1
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
-        self.remove()
+        if remove:
+            self.remove()
         try:
             self.add()
         except dbus.exceptions.DBusException as error:
-            logger.critical("D-Bus Exception", exc_info=error)
-            self.cleanup()
-            os._exit(1)
-        self.rename_count += 1
+            if (error.get_dbus_name()
+                == "org.freedesktop.Avahi.CollisionError"):
+                logger.info("Local Zeroconf service name collision.")
+                return self.rename(remove=False)
+            else:
+                logger.critical("D-Bus Exception", exc_info=error)
+                self.cleanup()
+                os._exit(1)
     
     def remove(self):
         """Derived from the Avahi example code"""
@@ -337,9 +351,8 @@
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical("Avahi: Error in group state changed %s",
-                            unicode(error))
-            raise AvahiGroupError("State changed: {!s}"
-                                  .format(error))
+                            str(error))
+            raise AvahiGroupError("State changed: {!s}".format(error))
     
     def cleanup(self):
         """Derived from the Avahi example code"""
@@ -355,13 +368,12 @@
     def server_state_changed(self, state, error=None):
         """Derived from the Avahi example code"""
         logger.debug("Avahi server state change: %i", state)
-        bad_states = { avahi.SERVER_INVALID:
-                           "Zeroconf server invalid",
-                       avahi.SERVER_REGISTERING: None,
-                       avahi.SERVER_COLLISION:
-                           "Zeroconf server name collision",
-                       avahi.SERVER_FAILURE:
-                           "Zeroconf server failure" }
+        bad_states = {
+            avahi.SERVER_INVALID: "Zeroconf server invalid",
+            avahi.SERVER_REGISTERING: None,
+            avahi.SERVER_COLLISION: "Zeroconf server name collision",
+            avahi.SERVER_FAILURE: "Zeroconf server failure",
+        }
         if state in bad_states:
             if bad_states[state] is not None:
                 if error is None:
@@ -386,18 +398,17 @@
                                     follow_name_owner_changes=True),
                 avahi.DBUS_INTERFACE_SERVER)
         self.server.connect_to_signal("StateChanged",
-                                 self.server_state_changed)
+                                      self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
 
 class AvahiServiceToSyslog(AvahiService):
-    def rename(self):
+    def rename(self, *args, **kwargs):
         """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self)
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
-                                ' %(levelname)s: %(message)s'
-                                .format(self.name)))
+        ret = AvahiService.rename(self, *args, **kwargs)
+        syslogger.setFormatter(logging.Formatter(
+            'Mandos ({}) [%(process)d]: %(levelname)s: %(message)s'
+            .format(self.name)))
         return ret
 
 
@@ -450,16 +461,17 @@
                           "fingerprint", "host", "interval",
                           "last_approval_request", "last_checked_ok",
                           "last_enabled", "name", "timeout")
-    client_defaults = { "timeout": "PT5M",
-                        "extended_timeout": "PT15M",
-                        "interval": "PT2M",
-                        "checker": "fping -q -- %%(host)s",
-                        "host": "",
-                        "approval_delay": "PT0S",
-                        "approval_duration": "PT1S",
-                        "approved_by_default": "True",
-                        "enabled": "True",
-                        }
+    client_defaults = {
+        "timeout": "PT5M",
+        "extended_timeout": "PT15M",
+        "interval": "PT2M",
+        "checker": "fping -q -- %%(host)s",
+        "host": "",
+        "approval_delay": "PT0S",
+        "approval_duration": "PT1S",
+        "approved_by_default": "True",
+        "enabled": "True",
+    }
     
     @staticmethod
     def config_parser(config):
@@ -481,6 +493,9 @@
             client["enabled"] = config.getboolean(client_name,
                                                   "enabled")
             
+            # Uppercase and remove spaces from fingerprint for later
+            # comparison purposes with return value from the
+            # fingerprint() function
             client["fingerprint"] = (section["fingerprint"].upper()
                                      .replace(" ", ""))
             if "secret" in section:
@@ -528,9 +543,6 @@
             self.expires = None
         
         logger.debug("Creating client %r", self.name)
-        # Uppercase and remove spaces from fingerprint for later
-        # comparison purposes with return value from the fingerprint()
-        # function
         logger.debug("  Fingerprint: %s", self.fingerprint)
         self.created = settings.get("created",
                                     datetime.datetime.utcnow())
@@ -543,18 +555,15 @@
         self.current_checker_command = None
         self.approved = None
         self.approvals_pending = 0
-        self.changedstate = (multiprocessing_manager
-                             .Condition(multiprocessing_manager
-                                        .Lock()))
-        self.client_structure = [attr for attr in
-                                 self.__dict__.iterkeys()
+        self.changedstate = multiprocessing_manager.Condition(
+            multiprocessing_manager.Lock())
+        self.client_structure = [attr
+                                 for attr in self.__dict__.iterkeys()
                                  if not attr.startswith("_")]
         self.client_structure.append("client_structure")
         
-        for name, t in inspect.getmembers(type(self),
-                                          lambda obj:
-                                              isinstance(obj,
-                                                         property)):
+        for name, t in inspect.getmembers(
+                type(self), lambda obj: isinstance(obj, property)):
             if not name.startswith("_"):
                 self.client_structure.append(name)
     
@@ -602,17 +611,14 @@
         # and every interval from then on.
         if self.checker_initiator_tag is not None:
             gobject.source_remove(self.checker_initiator_tag)
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (int(self.interval
-                                           .total_seconds() * 1000),
-                                       self.start_checker))
+        self.checker_initiator_tag = gobject.timeout_add(
+            int(self.interval.total_seconds() * 1000),
+            self.start_checker)
         # Schedule a disable() when 'timeout' has passed
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
-        self.disable_initiator_tag = (gobject.timeout_add
-                                      (int(self.timeout
-                                           .total_seconds() * 1000),
-                                       self.disable))
+        self.disable_initiator_tag = gobject.timeout_add(
+            int(self.timeout.total_seconds() * 1000), self.disable)
         # Also start a new checker *right now*.
         self.start_checker()
     
@@ -627,8 +633,7 @@
                             vars(self))
                 self.checked_ok()
             else:
-                logger.info("Checker for %(name)s failed",
-                            vars(self))
+                logger.info("Checker for %(name)s failed", vars(self))
         else:
             self.last_checker_status = -1
             logger.warning("Checker for %(name)s crashed?",
@@ -648,9 +653,8 @@
             gobject.source_remove(self.disable_initiator_tag)
             self.disable_initiator_tag = None
         if getattr(self, "enabled", False):
-            self.disable_initiator_tag = (gobject.timeout_add
-                                          (int(timeout.total_seconds()
-                                               * 1000), self.disable))
+            self.disable_initiator_tag = gobject.timeout_add(
+                int(timeout.total_seconds() * 1000), self.disable)
             self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
@@ -687,20 +691,20 @@
         # Start a new checker if needed
         if self.checker is None:
             # Escape attributes for the shell
-            escaped_attrs = { attr:
-                                  re.escape(unicode(getattr(self,
-                                                            attr)))
-                              for attr in self.runtime_expansions }
+            escaped_attrs = {
+                attr: re.escape(str(getattr(self, attr)))
+                for attr in self.runtime_expansions }
             try:
                 command = self.checker_command % escaped_attrs
             except TypeError as error:
                 logger.error('Could not format string "%s"',
-                             self.checker_command, exc_info=error)
-                return True # Try again later
+                             self.checker_command,
+                             exc_info=error)
+                return True     # Try again later
             self.current_checker_command = command
             try:
-                logger.info("Starting checker %r for %s",
-                            command, self.name)
+                logger.info("Starting checker %r for %s", command,
+                            self.name)
                 # We don't need to redirect stdout and stderr, since
                 # in normal mode, that is already done by daemon(),
                 # and in debug mode we don't want to.  (Stdin is
@@ -715,16 +719,15 @@
                                        "stderr": wnull })
                 self.checker = subprocess.Popen(command,
                                                 close_fds=True,
-                                                shell=True, cwd="/",
+                                                shell=True,
+                                                cwd="/",
                                                 **popen_args)
             except OSError as error:
                 logger.error("Failed to start subprocess",
                              exc_info=error)
                 return True
-            self.checker_callback_tag = (gobject.child_watch_add
-                                         (self.checker.pid,
-                                          self.checker_callback,
-                                          data=command))
+            self.checker_callback_tag = gobject.child_watch_add(
+                self.checker.pid, self.checker_callback, data=command)
             # The checker may have completed before the gobject
             # watch was added.  Check for this.
             try:
@@ -761,8 +764,10 @@
         self.checker = None
 
 
-def dbus_service_property(dbus_interface, signature="v",
-                          access="readwrite", byte_arrays=False):
+def dbus_service_property(dbus_interface,
+                          signature="v",
+                          access="readwrite",
+                          byte_arrays=False):
     """Decorators for marking methods of a DBusObjectWithProperties to
     become properties on the D-Bus.
     
@@ -778,6 +783,7 @@
     if byte_arrays and signature != "ay":
         raise ValueError("Byte arrays not supported for non-'ay'"
                          " signature {!r}".format(signature))
+    
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
@@ -788,6 +794,7 @@
             func._dbus_name = func._dbus_name[:-14]
         func._dbus_get_args_options = {'byte_arrays': byte_arrays }
         return func
+    
     return decorator
 
 
@@ -802,11 +809,13 @@
                 "org.freedesktop.DBus.Property.EmitsChangedSignal":
                     "false"}
     """
+    
     def decorator(func):
         func._dbus_is_interface = True
         func._dbus_interface = dbus_interface
         func._dbus_name = dbus_interface
         return func
+    
     return decorator
 
 
@@ -814,25 +823,26 @@
     """Decorator to annotate D-Bus methods, signals or properties
     Usage:
     
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true",
+                       "org.freedesktop.DBus.Property."
+                       "EmitsChangedSignal": "false"})
     @dbus_service_property("org.example.Interface", signature="b",
                            access="r")
-    @dbus_annotations({{"org.freedesktop.DBus.Deprecated": "true",
-                        "org.freedesktop.DBus.Property."
-                        "EmitsChangedSignal": "false"})
     def Property_dbus_property(self):
         return dbus.Boolean(False)
     """
+    
     def decorator(func):
         func._dbus_annotations = annotations
         return func
+    
     return decorator
 
 
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
-    def __unicode__(self):
-        return unicode(str(self))
+    pass
 
 
 class DBusPropertyAccessException(DBusPropertyException):
@@ -868,32 +878,29 @@
     def _get_all_dbus_things(self, thing):
         """Returns a generator of (name, attribute) pairs
         """
-        return ((getattr(athing.__get__(self), "_dbus_name",
-                         name),
+        return ((getattr(athing.__get__(self), "_dbus_name", name),
                  athing.__get__(self))
                 for cls in self.__class__.__mro__
                 for name, athing in
-                inspect.getmembers(cls,
-                                   self._is_dbus_thing(thing)))
+                inspect.getmembers(cls, self._is_dbus_thing(thing)))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
-        for cls in  self.__class__.__mro__:
-            for name, value in (inspect.getmembers
-                                (cls,
-                                 self._is_dbus_thing("property"))):
+        for cls in self.__class__.__mro__:
+            for name, value in inspect.getmembers(
+                    cls, self._is_dbus_thing("property")):
                 if (value._dbus_name == property_name
                     and value._dbus_interface == interface_name):
                     return value.__get__(self)
         
         # No such property
-        raise DBusPropertyNotFound(self.dbus_object_path + ":"
-                                   + interface_name + "."
-                                   + property_name)
+        raise DBusPropertyNotFound("{}:{}.{}".format(
+            self.dbus_object_path, interface_name, property_name))
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="ss",
+    @dbus.service.method(dbus.PROPERTIES_IFACE,
+                         in_signature="ss",
                          out_signature="v")
     def Get(self, interface_name, property_name):
         """Standard D-Bus property Get() method, see D-Bus standard.
@@ -924,7 +931,8 @@
                                             for byte in value))
         prop(value)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="s",
+    @dbus.service.method(dbus.PROPERTIES_IFACE,
+                         in_signature="s",
                          out_signature="a{sv}")
     def GetAll(self, interface_name):
         """Standard D-Bus property GetAll() method, see D-Bus
@@ -945,10 +953,18 @@
             if not hasattr(value, "variant_level"):
                 properties[name] = value
                 continue
-            properties[name] = type(value)(value, variant_level=
-                                           value.variant_level+1)
+            properties[name] = type(value)(
+                value, variant_level = value.variant_level + 1)
         return dbus.Dictionary(properties, signature="sv")
     
+    @dbus.service.signal(dbus.PROPERTIES_IFACE, signature="sa{sv}as")
+    def PropertiesChanged(self, interface_name, changed_properties,
+                          invalidated_properties):
+        """Standard D-Bus PropertiesChanged() signal, see D-Bus
+        standard.
+        """
+        pass
+    
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature="s",
                          path_keyword='object_path',
@@ -962,12 +978,14 @@
                                                    connection)
         try:
             document = xml.dom.minidom.parseString(xmlstring)
+            
             def make_tag(document, name, prop):
                 e = document.createElement("property")
                 e.setAttribute("name", name)
                 e.setAttribute("type", prop._dbus_signature)
                 e.setAttribute("access", prop._dbus_access)
                 return e
+            
             for if_tag in document.getElementsByTagName("interface"):
                 # Add property tags
                 for tag in (make_tag(document, name, prop)
@@ -985,10 +1003,8 @@
                             if (name == tag.getAttribute("name")
                                 and prop._dbus_interface
                                 == if_tag.getAttribute("name")):
-                                annots.update(getattr
-                                              (prop,
-                                               "_dbus_annotations",
-                                               {}))
+                                annots.update(getattr(
+                                    prop, "_dbus_annotations", {}))
                         for name, value in annots.items():
                             ann_tag = document.createElement(
                                 "annotation")
@@ -999,8 +1015,8 @@
                 for annotation, value in dict(
                     itertools.chain.from_iterable(
                         annotations().items()
-                        for name, annotations in
-                        self._get_all_dbus_things("interface")
+                        for name, annotations
+                        in self._get_all_dbus_things("interface")
                         if name == if_tag.getAttribute("name")
                         )).items():
                     ann_tag = document.createElement("annotation")
@@ -1035,8 +1051,7 @@
     """Convert a UTC datetime.datetime() to a D-Bus type."""
     if dt is None:
         return dbus.String("", variant_level = variant_level)
-    return dbus.String(dt.isoformat(),
-                       variant_level=variant_level)
+    return dbus.String(dt.isoformat(), variant_level=variant_level)
 
 
 def alternate_dbus_interfaces(alt_interface_names, deprecate=True):
@@ -1062,9 +1077,10 @@
     (from DBusObjectWithProperties) and interfaces (from the
     dbus_interface_annotations decorator).
     """
+    
     def wrapper(cls):
         for orig_interface_name, alt_interface_name in (
-            alt_interface_names.items()):
+                alt_interface_names.items()):
             attr = {}
             interface_names = set()
             # Go though all attributes of the class
@@ -1072,39 +1088,37 @@
                 # Ignore non-D-Bus attributes, and D-Bus attributes
                 # with the wrong interface name
                 if (not hasattr(attribute, "_dbus_interface")
-                    or not attribute._dbus_interface
-                    .startswith(orig_interface_name)):
+                    or not attribute._dbus_interface.startswith(
+                        orig_interface_name)):
                     continue
                 # Create an alternate D-Bus interface name based on
                 # the current name
-                alt_interface = (attribute._dbus_interface
-                                 .replace(orig_interface_name,
-                                          alt_interface_name))
+                alt_interface = attribute._dbus_interface.replace(
+                    orig_interface_name, alt_interface_name)
                 interface_names.add(alt_interface)
                 # Is this a D-Bus signal?
                 if getattr(attribute, "_dbus_is_signal", False):
                     # Extract the original non-method undecorated
                     # function by black magic
                     nonmethod_func = (dict(
-                            zip(attribute.func_code.co_freevars,
-                                attribute.__closure__))["func"]
-                                      .cell_contents)
+                        zip(attribute.func_code.co_freevars,
+                            attribute.__closure__))
+                                      ["func"].cell_contents)
                     # Create a new, but exactly alike, function
                     # object, and decorate it to be a new D-Bus signal
                     # with the alternate D-Bus interface name
-                    new_function = (dbus.service.signal
-                                    (alt_interface,
-                                     attribute._dbus_signature)
+                    new_function = (dbus.service.signal(
+                        alt_interface, attribute._dbus_signature)
                                     (types.FunctionType(
-                                nonmethod_func.func_code,
-                                nonmethod_func.func_globals,
-                                nonmethod_func.func_name,
-                                nonmethod_func.func_defaults,
-                                nonmethod_func.func_closure)))
+                                        nonmethod_func.func_code,
+                                        nonmethod_func.func_globals,
+                                        nonmethod_func.func_name,
+                                        nonmethod_func.func_defaults,
+                                        nonmethod_func.func_closure)))
                     # Copy annotations, if any
                     try:
-                        new_function._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
+                        new_function._dbus_annotations = dict(
+                            attribute._dbus_annotations)
                     except AttributeError:
                         pass
                     # Define a creator of a function to call both the
@@ -1115,11 +1129,13 @@
                         """This function is a scope container to pass
                         func1 and func2 to the "call_both" function
                         outside of its arguments"""
+                        
                         def call_both(*args, **kwargs):
                             """This function will emit two D-Bus
                             signals by calling func1 and func2"""
                             func1(*args, **kwargs)
                             func2(*args, **kwargs)
+                        
                         return call_both
                     # Create the "call_both" function and add it to
                     # the class
@@ -1130,20 +1146,20 @@
                     # object.  Decorate it to be a new D-Bus method
                     # with the alternate D-Bus interface name.  Add it
                     # to the class.
-                    attr[attrname] = (dbus.service.method
-                                      (alt_interface,
-                                       attribute._dbus_in_signature,
-                                       attribute._dbus_out_signature)
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
+                    attr[attrname] = (
+                        dbus.service.method(
+                            alt_interface,
+                            attribute._dbus_in_signature,
+                            attribute._dbus_out_signature)
+                        (types.FunctionType(attribute.func_code,
+                                            attribute.func_globals,
+                                            attribute.func_name,
+                                            attribute.func_defaults,
+                                            attribute.func_closure)))
                     # Copy annotations, if any
                     try:
-                        attr[attrname]._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
+                        attr[attrname]._dbus_annotations = dict(
+                            attribute._dbus_annotations)
                     except AttributeError:
                         pass
                 # Is this a D-Bus property?
@@ -1152,23 +1168,21 @@
                     # object, and decorate it to be a new D-Bus
                     # property with the alternate D-Bus interface
                     # name.  Add it to the class.
-                    attr[attrname] = (dbus_service_property
-                                      (alt_interface,
-                                       attribute._dbus_signature,
-                                       attribute._dbus_access,
-                                       attribute
-                                       ._dbus_get_args_options
-                                       ["byte_arrays"])
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
+                    attr[attrname] = (dbus_service_property(
+                        alt_interface, attribute._dbus_signature,
+                        attribute._dbus_access,
+                        attribute._dbus_get_args_options
+                        ["byte_arrays"])
+                                      (types.FunctionType(
+                                          attribute.func_code,
+                                          attribute.func_globals,
+                                          attribute.func_name,
+                                          attribute.func_defaults,
+                                          attribute.func_closure)))
                     # Copy annotations, if any
                     try:
-                        attr[attrname]._dbus_annotations = (
-                            dict(attribute._dbus_annotations))
+                        attr[attrname]._dbus_annotations = dict(
+                            attribute._dbus_annotations)
                     except AttributeError:
                         pass
                 # Is this a D-Bus interface?
@@ -1177,22 +1191,22 @@
                     # object.  Decorate it to be a new D-Bus interface
                     # with the alternate D-Bus interface name.  Add it
                     # to the class.
-                    attr[attrname] = (dbus_interface_annotations
-                                      (alt_interface)
-                                      (types.FunctionType
-                                       (attribute.func_code,
-                                        attribute.func_globals,
-                                        attribute.func_name,
-                                        attribute.func_defaults,
-                                        attribute.func_closure)))
+                    attr[attrname] = (
+                        dbus_interface_annotations(alt_interface)
+                        (types.FunctionType(attribute.func_code,
+                                            attribute.func_globals,
+                                            attribute.func_name,
+                                            attribute.func_defaults,
+                                            attribute.func_closure)))
             if deprecate:
                 # Deprecate all alternate interfaces
                 iname="_AlternateDBusNames_interface_annotation{}"
                 for interface_name in interface_names:
+                    
                     @dbus_interface_annotations(interface_name)
                     def func(self):
                         return { "org.freedesktop.DBus.Deprecated":
-                                     "true" }
+                                 "true" }
                     # Find an unused name
                     for aname in (iname.format(i)
                                   for i in itertools.count()):
@@ -1203,13 +1217,14 @@
                 # Replace the class with a new subclass of it with
                 # methods, signals, etc. as created above.
                 cls = type(b"{}Alternate".format(cls.__name__),
-                           (cls,), attr)
+                           (cls, ), attr)
         return cls
+    
     return wrapper
 
 
 @alternate_dbus_interfaces({"se.recompile.Mandos":
-                                "se.bsnet.fukt.Mandos"})
+                            "se.bsnet.fukt.Mandos"})
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
@@ -1219,7 +1234,9 @@
     """
     
     runtime_expansions = (Client.runtime_expansions
-                          + ("dbus_object_path",))
+                          + ("dbus_object_path", ))
+    
+    _interface = "se.recompile.Mandos.Client"
     
     # dbus.service.Object doesn't use super(), so we can't either.
     
@@ -1228,17 +1245,19 @@
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
-        client_object_name = unicode(self.name).translate(
+        client_object_name = str(self.name).translate(
             {ord("."): ord("_"),
              ord("-"): ord("_")})
-        self.dbus_object_path = (dbus.ObjectPath
-                                 ("/clients/" + client_object_name))
+        self.dbus_object_path = dbus.ObjectPath(
+            "/clients/" + client_object_name)
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
     
-    def notifychangeproperty(transform_func,
-                             dbus_name, type_func=lambda x: x,
-                             variant_level=1):
+    def notifychangeproperty(transform_func, dbus_name,
+                             type_func=lambda x: x,
+                             variant_level=1,
+                             invalidate_only=False,
+                             _interface=_interface):
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
         
@@ -1250,16 +1269,27 @@
         variant_level: D-Bus variant level.  Default: 1
         """
         attrname = "_{}".format(dbus_name)
+        
         def setter(self, value):
             if hasattr(self, "dbus_object_path"):
                 if (not hasattr(self, attrname) or
                     type_func(getattr(self, attrname, None))
                     != type_func(value)):
-                    dbus_value = transform_func(type_func(value),
-                                                variant_level
-                                                =variant_level)
-                    self.PropertyChanged(dbus.String(dbus_name),
-                                         dbus_value)
+                    if invalidate_only:
+                        self.PropertiesChanged(
+                            _interface, dbus.Dictionary(),
+                            dbus.Array((dbus_name, )))
+                    else:
+                        dbus_value = transform_func(
+                            type_func(value),
+                            variant_level = variant_level)
+                        self.PropertyChanged(dbus.String(dbus_name),
+                                             dbus_value)
+                        self.PropertiesChanged(
+                            _interface,
+                            dbus.Dictionary({ dbus.String(dbus_name):
+                                              dbus_value }),
+                            dbus.Array())
             setattr(self, attrname, value)
         
         return property(lambda self: getattr(self, attrname), setter)
@@ -1271,9 +1301,9 @@
     enabled = notifychangeproperty(dbus.Boolean, "Enabled")
     last_enabled = notifychangeproperty(datetime_to_dbus,
                                         "LastEnabled")
-    checker = notifychangeproperty(dbus.Boolean, "CheckerRunning",
-                                   type_func = lambda checker:
-                                       checker is not None)
+    checker = notifychangeproperty(
+        dbus.Boolean, "CheckerRunning",
+        type_func = lambda checker: checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
     last_checker_status = notifychangeproperty(dbus.Int16,
@@ -1282,27 +1312,25 @@
         datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
                                                "ApprovedByDefault")
-    approval_delay = notifychangeproperty(dbus.UInt64,
-                                          "ApprovalDelay",
-                                          type_func =
-                                          lambda td: td.total_seconds()
-                                          * 1000)
+    approval_delay = notifychangeproperty(
+        dbus.UInt64, "ApprovalDelay",
+        type_func = lambda td: td.total_seconds() * 1000)
     approval_duration = notifychangeproperty(
         dbus.UInt64, "ApprovalDuration",
         type_func = lambda td: td.total_seconds() * 1000)
     host = notifychangeproperty(dbus.String, "Host")
-    timeout = notifychangeproperty(dbus.UInt64, "Timeout",
-                                   type_func = lambda td:
-                                       td.total_seconds() * 1000)
+    timeout = notifychangeproperty(
+        dbus.UInt64, "Timeout",
+        type_func = lambda td: td.total_seconds() * 1000)
     extended_timeout = notifychangeproperty(
         dbus.UInt64, "ExtendedTimeout",
         type_func = lambda td: td.total_seconds() * 1000)
-    interval = notifychangeproperty(dbus.UInt64,
-                                    "Interval",
-                                    type_func =
-                                    lambda td: td.total_seconds()
-                                    * 1000)
+    interval = notifychangeproperty(
+        dbus.UInt64, "Interval",
+        type_func = lambda td: td.total_seconds() * 1000)
     checker_command = notifychangeproperty(dbus.String, "Checker")
+    secret = notifychangeproperty(dbus.ByteArray, "Secret",
+                                  invalidate_only=True)
     
     del notifychangeproperty
     
@@ -1355,15 +1383,9 @@
         self.send_changedstate()
     
     ## D-Bus methods, signals & properties
-    _interface = "se.recompile.Mandos.Client"
     
     ## Interfaces
     
-    @dbus_interface_annotations(_interface)
-    def _foo(self):
-        return { "org.freedesktop.DBus.Property.EmitsChangedSignal":
-                     "false"}
-    
     ## Signals
     
     # CheckerCompleted - signal
@@ -1379,6 +1401,7 @@
         pass
     
     # PropertyChanged - signal
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.signal(_interface, signature="sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
@@ -1448,7 +1471,8 @@
         return dbus.Boolean(bool(self.approvals_pending))
     
     # ApprovedByDefault - property
-    @dbus_service_property(_interface, signature="b",
+    @dbus_service_property(_interface,
+                           signature="b",
                            access="readwrite")
     def ApprovedByDefault_dbus_property(self, value=None):
         if value is None:       # get
@@ -1456,7 +1480,8 @@
         self.approved_by_default = bool(value)
     
     # ApprovalDelay - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def ApprovalDelay_dbus_property(self, value=None):
         if value is None:       # get
@@ -1465,7 +1490,8 @@
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
     
     # ApprovalDuration - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
@@ -1484,12 +1510,13 @@
         return dbus.String(self.fingerprint)
     
     # Host - property
-    @dbus_service_property(_interface, signature="s",
+    @dbus_service_property(_interface,
+                           signature="s",
                            access="readwrite")
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = unicode(value)
+        self.host = str(value)
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1502,7 +1529,8 @@
         return datetime_to_dbus(self.last_enabled)
     
     # Enabled - property
-    @dbus_service_property(_interface, signature="b",
+    @dbus_service_property(_interface,
+                           signature="b",
                            access="readwrite")
     def Enabled_dbus_property(self, value=None):
         if value is None:       # get
@@ -1513,7 +1541,8 @@
             self.disable()
     
     # LastCheckedOK - property
-    @dbus_service_property(_interface, signature="s",
+    @dbus_service_property(_interface,
+                           signature="s",
                            access="readwrite")
     def LastCheckedOK_dbus_property(self, value=None):
         if value is not None:
@@ -1522,8 +1551,7 @@
         return datetime_to_dbus(self.last_checked_ok)
     
     # LastCheckerStatus - property
-    @dbus_service_property(_interface, signature="n",
-                           access="read")
+    @dbus_service_property(_interface, signature="n", access="read")
     def LastCheckerStatus_dbus_property(self):
         return dbus.Int16(self.last_checker_status)
     
@@ -1538,7 +1566,8 @@
         return datetime_to_dbus(self.last_approval_request)
     
     # Timeout - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
@@ -1557,13 +1586,13 @@
                     is None):
                     return
                 gobject.source_remove(self.disable_initiator_tag)
-                self.disable_initiator_tag = (
-                    gobject.timeout_add(
-                        int((self.expires - now).total_seconds()
-                            * 1000), self.disable))
+                self.disable_initiator_tag = gobject.timeout_add(
+                    int((self.expires - now).total_seconds() * 1000),
+                    self.disable)
     
     # ExtendedTimeout - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def ExtendedTimeout_dbus_property(self, value=None):
         if value is None:       # get
@@ -1572,7 +1601,8 @@
         self.extended_timeout = datetime.timedelta(0, 0, 0, value)
     
     # Interval - property
-    @dbus_service_property(_interface, signature="t",
+    @dbus_service_property(_interface,
+                           signature="t",
                            access="readwrite")
     def Interval_dbus_property(self, value=None):
         if value is None:       # get
@@ -1583,20 +1613,22 @@
         if self.enabled:
             # Reschedule checker run
             gobject.source_remove(self.checker_initiator_tag)
-            self.checker_initiator_tag = (gobject.timeout_add
-                                          (value, self.start_checker))
-            self.start_checker()    # Start one now, too
+            self.checker_initiator_tag = gobject.timeout_add(
+                value, self.start_checker)
+            self.start_checker() # Start one now, too
     
     # Checker - property
-    @dbus_service_property(_interface, signature="s",
+    @dbus_service_property(_interface,
+                           signature="s",
                            access="readwrite")
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = unicode(value)
+        self.checker_command = str(value)
     
     # CheckerRunning - property
-    @dbus_service_property(_interface, signature="b",
+    @dbus_service_property(_interface,
+                           signature="b",
                            access="readwrite")
     def CheckerRunning_dbus_property(self, value=None):
         if value is None:       # get
@@ -1612,10 +1644,12 @@
         return self.dbus_object_path # is already a dbus.ObjectPath
     
     # Secret = property
-    @dbus_service_property(_interface, signature="ay",
-                           access="write", byte_arrays=True)
+    @dbus_service_property(_interface,
+                           signature="ay",
+                           access="write",
+                           byte_arrays=True)
     def Secret_dbus_property(self, value):
-        self.secret = str(value)
+        self.secret = bytes(value)
     
     del _interface
 
@@ -1635,9 +1669,11 @@
         if data[0] == 'data':
             return data[1]
         if data[0] == 'function':
+            
             def func(*args, **kwargs):
                 self._pipe.send(('funcall', name, args, kwargs))
                 return self._pipe.recv()[1]
+            
             return func
     
     def __setattr__(self, name, value):
@@ -1655,14 +1691,12 @@
     def handle(self):
         with contextlib.closing(self.server.child_pipe) as child_pipe:
             logger.info("TCP connection from: %s",
-                        unicode(self.client_address))
+                        str(self.client_address))
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
             
-            session = (gnutls.connection
-                       .ClientSession(self.request,
-                                      gnutls.connection
-                                      .X509Credentials()))
+            session = gnutls.connection.ClientSession(
+                self.request, gnutls.connection .X509Credentials())
             
             # Note: gnutls.connection.X509Credentials is really a
             # generic GnuTLS certificate credentials object so long as
@@ -1677,9 +1711,8 @@
             priority = self.server.gnutls_priority
             if priority is None:
                 priority = "NORMAL"
-            (gnutls.library.functions
-             .gnutls_priority_set_direct(session._c_object,
-                                         priority, None))
+            gnutls.library.functions.gnutls_priority_set_direct(
+                session._c_object, priority, None)
             
             # Start communication using the Mandos protocol
             # Get protocol number
@@ -1705,8 +1738,8 @@
             approval_required = False
             try:
                 try:
-                    fpr = self.fingerprint(self.peer_certificate
-                                           (session))
+                    fpr = self.fingerprint(
+                        self.peer_certificate(session))
                 except (TypeError,
                         gnutls.errors.GNUTLSError) as error:
                     logger.warning("Bad certificate: %s", error)
@@ -1727,7 +1760,7 @@
                 while True:
                     if not client.enabled:
                         logger.info("Client %s is disabled",
-                                       client.name)
+                                    client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
                             client.Rejected("Disabled")
@@ -1780,9 +1813,9 @@
                         logger.warning("gnutls send failed",
                                        exc_info=error)
                         return
-                    logger.debug("Sent: %d, remaining: %d",
-                                 sent, len(client.secret)
-                                 - (sent_size + sent))
+                    logger.debug("Sent: %d, remaining: %d", sent,
+                                 len(client.secret) - (sent_size
+                                                       + sent))
                     sent_size += sent
                 
                 logger.info("Sending secret to %s", client.name)
@@ -1805,8 +1838,8 @@
     def peer_certificate(session):
         "Return the peer's OpenPGP certificate as a bytestring"
         # If not an OpenPGP certificate...
-        if (gnutls.library.functions
-            .gnutls_certificate_type_get(session._c_object)
+        if (gnutls.library.functions.gnutls_certificate_type_get(
+                session._c_object)
             != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
             # ...do the normal thing
             return session.peer_certificate
@@ -1826,36 +1859,32 @@
     def fingerprint(openpgp):
         "Convert an OpenPGP bytestring to a hexdigit fingerprint"
         # New GnuTLS "datum" with the OpenPGP public key
-        datum = (gnutls.library.types
-                 .gnutls_datum_t(ctypes.cast(ctypes.c_char_p(openpgp),
-                                             ctypes.POINTER
-                                             (ctypes.c_ubyte)),
-                                 ctypes.c_uint(len(openpgp))))
+        datum = gnutls.library.types.gnutls_datum_t(
+            ctypes.cast(ctypes.c_char_p(openpgp),
+                        ctypes.POINTER(ctypes.c_ubyte)),
+            ctypes.c_uint(len(openpgp)))
         # New empty GnuTLS certificate
         crt = gnutls.library.types.gnutls_openpgp_crt_t()
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_init(ctypes.byref(crt)))
+        gnutls.library.functions.gnutls_openpgp_crt_init(
+            ctypes.byref(crt))
         # Import the OpenPGP public key into the certificate
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_import(crt, ctypes.byref(datum),
-                                    gnutls.library.constants
-                                    .GNUTLS_OPENPGP_FMT_RAW))
+        gnutls.library.functions.gnutls_openpgp_crt_import(
+            crt, ctypes.byref(datum),
+            gnutls.library.constants.GNUTLS_OPENPGP_FMT_RAW)
         # Verify the self signature in the key
         crtverify = ctypes.c_uint()
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_verify_self(crt, 0,
-                                         ctypes.byref(crtverify)))
+        gnutls.library.functions.gnutls_openpgp_crt_verify_self(
+            crt, 0, ctypes.byref(crtverify))
         if crtverify.value != 0:
             gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
-            raise (gnutls.errors.CertificateSecurityError
-                   ("Verify failed"))
+            raise gnutls.errors.CertificateSecurityError(
+                "Verify failed")
         # New buffer for the fingerprint
         buf = ctypes.create_string_buffer(20)
         buf_len = ctypes.c_size_t()
         # Get the fingerprint from the certificate into the buffer
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_get_fingerprint(crt, ctypes.byref(buf),
-                                             ctypes.byref(buf_len)))
+        gnutls.library.functions.gnutls_openpgp_crt_get_fingerprint(
+            crt, ctypes.byref(buf), ctypes.byref(buf_len))
         # Deinit the certificate
         gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
         # Convert the buffer to a Python bytestring
@@ -1867,6 +1896,7 @@
 
 class MultiprocessingMixIn(object):
     """Like socketserver.ThreadingMixIn, but with multiprocessing"""
+    
     def sub_process_main(self, request, address):
         try:
             self.finish_request(request, address)
@@ -1884,6 +1914,7 @@
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
     """ adds a pipe to the MixIn """
+    
     def process_request(self, request, client_address):
         """Overrides and wraps the original process_request().
         
@@ -1910,8 +1941,11 @@
         interface:      None or a network interface name (string)
         use_ipv6:       Boolean; to use IPv6 or not
     """
+    
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None, use_ipv6=True, socketfd=None):
+                 interface=None,
+                 use_ipv6=True,
+                 socketfd=None):
         """If socketfd is set, use that file descriptor instead of
         creating a new one with socket.socket().
         """
@@ -1958,9 +1992,9 @@
                              self.interface)
             else:
                 try:
-                    self.socket.setsockopt(socket.SOL_SOCKET,
-                                           SO_BINDTODEVICE,
-                                           str(self.interface + '\0'))
+                    self.socket.setsockopt(
+                        socket.SOL_SOCKET, SO_BINDTODEVICE,
+                        (self.interface + "\0").encode("utf-8"))
                 except socket.error as error:
                     if error.errno == errno.EPERM:
                         logger.error("No permission to bind to"
@@ -1984,8 +2018,7 @@
                 self.server_address = (any_address,
                                        self.server_address[1])
             elif not self.server_address[1]:
-                self.server_address = (self.server_address[0],
-                                       0)
+                self.server_address = (self.server_address[0], 0)
 #                 if self.interface:
 #                     self.server_address = (self.server_address[0],
 #                                            0, # port
@@ -2005,9 +2038,14 @@
     
     Assumes a gobject.MainLoop event loop.
     """
+    
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None, use_ipv6=True, clients=None,
-                 gnutls_priority=None, use_dbus=True, socketfd=None):
+                 interface=None,
+                 use_ipv6=True,
+                 clients=None,
+                 gnutls_priority=None,
+                 use_dbus=True,
+                 socketfd=None):
         self.enabled = False
         self.clients = clients
         if self.clients is None:
@@ -2019,6 +2057,7 @@
                                 interface = interface,
                                 use_ipv6 = use_ipv6,
                                 socketfd = socketfd)
+    
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
@@ -2028,15 +2067,17 @@
     
     def add_pipe(self, parent_pipe, proc):
         # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(parent_pipe.fileno(),
-                             gobject.IO_IN | gobject.IO_HUP,
-                             functools.partial(self.handle_ipc,
-                                               parent_pipe =
-                                               parent_pipe,
-                                               proc = proc))
+        gobject.io_add_watch(
+            parent_pipe.fileno(),
+            gobject.IO_IN | gobject.IO_HUP,
+            functools.partial(self.handle_ipc,
+                              parent_pipe = parent_pipe,
+                              proc = proc))
     
-    def handle_ipc(self, source, condition, parent_pipe=None,
-                   proc = None, client_object=None):
+    def handle_ipc(self, source, condition,
+                   parent_pipe=None,
+                   proc = None,
+                   client_object=None):
         # error, or the other end of multiprocessing.Pipe has closed
         if condition & (gobject.IO_ERR | gobject.IO_HUP):
             # Wait for other process to exit
@@ -2065,14 +2106,13 @@
                 parent_pipe.send(False)
                 return False
             
-            gobject.io_add_watch(parent_pipe.fileno(),
-                                 gobject.IO_IN | gobject.IO_HUP,
-                                 functools.partial(self.handle_ipc,
-                                                   parent_pipe =
-                                                   parent_pipe,
-                                                   proc = proc,
-                                                   client_object =
-                                                   client))
+            gobject.io_add_watch(
+                parent_pipe.fileno(),
+                gobject.IO_IN | gobject.IO_HUP,
+                functools.partial(self.handle_ipc,
+                                  parent_pipe = parent_pipe,
+                                  proc = proc,
+                                  client_object = client))
             parent_pipe.send(True)
             # remove the old hook in favor of the new above hook on
             # same fileno
@@ -2084,15 +2124,15 @@
             
             parent_pipe.send(('data', getattr(client_object,
                                               funcname)(*args,
-                                                         **kwargs)))
+                                                        **kwargs)))
         
         if command == 'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
-                parent_pipe.send(('function',))
+                parent_pipe.send(('function', ))
             else:
-                parent_pipe.send(('data', client_object
-                                  .__getattribute__(attrname)))
+                parent_pipe.send((
+                    'data', client_object.__getattribute__(attrname)))
         
         if command == 'setattr':
             attrname = request[1]
@@ -2138,12 +2178,17 @@
                                               # None
                                     "followers")) # Tokens valid after
                                                   # this token
+    Token = collections.namedtuple("Token", (
+        "regexp",  # To match token; if "value" is not None, must have
+                   # a "group" containing digits
+        "value",   # datetime.timedelta or None
+        "followers"))           # Tokens valid after this token
     # RFC 3339 "duration" tokens, syntax, and semantics; taken from
     # the "duration" ABNF definition in RFC 3339, Appendix A.
     token_end = Token(re.compile(r"$"), None, frozenset())
     token_second = Token(re.compile(r"(\d+)S"),
                          datetime.timedelta(seconds=1),
-                         frozenset((token_end,)))
+                         frozenset((token_end, )))
     token_minute = Token(re.compile(r"(\d+)M"),
                          datetime.timedelta(minutes=1),
                          frozenset((token_second, token_end)))
@@ -2165,7 +2210,7 @@
                        frozenset((token_month, token_end)))
     token_week = Token(re.compile(r"(\d+)W"),
                        datetime.timedelta(weeks=1),
-                       frozenset((token_end,)))
+                       frozenset((token_end, )))
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
@@ -2226,7 +2271,7 @@
     timevalue = datetime.timedelta(0)
     for s in interval.split():
         try:
-            suffix = unicode(s[-1])
+            suffix = s[-1]
             value = int(s[:-1])
             if suffix == "d":
                 delta = datetime.timedelta(value)
@@ -2239,8 +2284,7 @@
             elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError("Unknown suffix {!r}"
-                                 .format(suffix))
+                raise ValueError("Unknown suffix {!r}".format(suffix))
         except IndexError as e:
             raise ValueError(*(e.args))
         timevalue += delta
@@ -2262,7 +2306,8 @@
         # Close all standard open file descriptors
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
-            raise OSError(errno.ENODEV, "{} not a character device"
+            raise OSError(errno.ENODEV,
+                          "{} not a character device"
                           .format(os.devnull))
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
@@ -2334,7 +2379,8 @@
                         "port": "",
                         "debug": "False",
                         "priority":
-                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160",
+                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA"
+                        ":+SIGN-RSA-SHA224:+SIGN-RSA-RMD160",
                         "servicename": "Mandos",
                         "use_dbus": "True",
                         "use_ipv6": "True",
@@ -2344,13 +2390,12 @@
                         "statedir": "/var/lib/mandos",
                         "foreground": "False",
                         "zeroconf": "True",
-                        }
+                    }
     
     # Parse config file for server-global settings
     server_config = configparser.SafeConfigParser(server_defaults)
     del server_defaults
-    server_config.read(os.path.join(options.configdir,
-                                    "mandos.conf"))
+    server_config.read(os.path.join(options.configdir, "mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use the appropriate methods on the non-string config options
@@ -2374,17 +2419,18 @@
     # Override the settings from the config file with command line
     # options, if set.
     for option in ("interface", "address", "port", "debug",
-                   "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket", "foreground", "zeroconf"):
+                   "priority", "servicename", "configdir", "use_dbus",
+                   "use_ipv6", "debuglevel", "restore", "statedir",
+                   "socket", "foreground", "zeroconf"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
     del options
     # Force all strings to be unicode
     for option in server_settings.keys():
-        if type(server_settings[option]) is str:
-            server_settings[option] = unicode(server_settings[option])
+        if isinstance(server_settings[option], bytes):
+            server_settings[option] = (server_settings[option]
+                                       .decode("utf-8"))
     # Force all boolean options to be boolean
     for option in ("debug", "use_dbus", "use_ipv6", "restore",
                    "foreground", "zeroconf"):
@@ -2396,11 +2442,10 @@
     
     ##################################################################
     
-    if (not server_settings["zeroconf"] and
-        not (server_settings["port"]
-             or server_settings["socket"] != "")):
-            parser.error("Needs port or socket to work without"
-                         " Zeroconf")
+    if (not server_settings["zeroconf"]
+        and not (server_settings["port"]
+                 or server_settings["socket"] != "")):
+        parser.error("Needs port or socket to work without Zeroconf")
     
     # For convenience
     debug = server_settings["debug"]
@@ -2422,11 +2467,10 @@
             initlogger(debug, level)
     
     if server_settings["servicename"] != "Mandos":
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
-                                ' %(levelname)s: %(message)s'
-                                .format(server_settings
-                                        ["servicename"])))
+        syslogger.setFormatter(
+            logging.Formatter('Mandos ({}) [%(process)d]:'
+                              ' %(levelname)s: %(message)s'.format(
+                                  server_settings["servicename"])))
     
     # Parse config file with clients
     client_config = configparser.SafeConfigParser(Client
@@ -2440,16 +2484,14 @@
     socketfd = None
     if server_settings["socket"] != "":
         socketfd = server_settings["socket"]
-    tcp_server = MandosServer((server_settings["address"],
-                               server_settings["port"]),
-                              ClientHandler,
-                              interface=(server_settings["interface"]
-                                         or None),
-                              use_ipv6=use_ipv6,
-                              gnutls_priority=
-                              server_settings["priority"],
-                              use_dbus=use_dbus,
-                              socketfd=socketfd)
+    tcp_server = MandosServer(
+        (server_settings["address"], server_settings["port"]),
+        ClientHandler,
+        interface=(server_settings["interface"] or None),
+        use_ipv6=use_ipv6,
+        gnutls_priority=server_settings["priority"],
+        use_dbus=use_dbus,
+        socketfd=socketfd)
     if not foreground:
         pidfilename = "/run/mandos.pid"
         if not os.path.isdir("/run/."):
@@ -2489,8 +2531,8 @@
         def debug_gnutls(level, string):
             logger.debug("GnuTLS: %s", string[:-1])
         
-        (gnutls.library.functions
-         .gnutls_global_set_log_function(debug_gnutls))
+        gnutls.library.functions.gnutls_global_set_log_function(
+            debug_gnutls)
         
         # Redirect stdin so all checkers get /dev/null
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
@@ -2516,10 +2558,11 @@
     if use_dbus:
         try:
             bus_name = dbus.service.BusName("se.recompile.Mandos",
-                                            bus, do_not_queue=True)
-            old_bus_name = (dbus.service.BusName
-                            ("se.bsnet.fukt.Mandos", bus,
-                             do_not_queue=True))
+                                            bus,
+                                            do_not_queue=True)
+            old_bus_name = dbus.service.BusName(
+                "se.bsnet.fukt.Mandos", bus,
+                do_not_queue=True)
         except dbus.exceptions.NameExistsException as e:
             logger.error("Disabling D-Bus:", exc_info=e)
             use_dbus = False
@@ -2527,13 +2570,14 @@
             tcp_server.use_dbus = False
     if zeroconf:
         protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-        service = AvahiServiceToSyslog(name =
-                                       server_settings["servicename"],
-                                       servicetype = "_mandos._tcp",
-                                       protocol = protocol, bus = bus)
+        service = AvahiServiceToSyslog(
+            name = server_settings["servicename"],
+            servicetype = "_mandos._tcp",
+            protocol = protocol,
+            bus = bus)
         if server_settings["interface"]:
-            service.interface = (if_nametoindex
-                                 (str(server_settings["interface"])))
+            service.interface = if_nametoindex(
+                server_settings["interface"].encode("utf-8"))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2558,20 +2602,21 @@
     if server_settings["restore"]:
         try:
             with open(stored_state_path, "rb") as stored_state:
-                clients_data, old_client_settings = (pickle.load
-                                                     (stored_state))
+                clients_data, old_client_settings = pickle.load(
+                    stored_state)
             os.remove(stored_state_path)
         except IOError as e:
             if e.errno == errno.ENOENT:
-                logger.warning("Could not load persistent state: {}"
-                                .format(os.strerror(e.errno)))
+                logger.warning("Could not load persistent state:"
+                               " {}".format(os.strerror(e.errno)))
             else:
                 logger.critical("Could not load persistent state:",
                                 exc_info=e)
                 raise
         except EOFError as e:
             logger.warning("Could not load persistent state: "
-                           "EOFError:", exc_info=e)
+                           "EOFError:",
+                           exc_info=e)
     
     with PGPEngine() as pgp:
         for client_name, client in clients_data.items():
@@ -2589,9 +2634,9 @@
                     # For each value in new config, check if it
                     # differs from the old config value (Except for
                     # the "secret" attribute)
-                    if (name != "secret" and
-                        value != old_client_settings[client_name]
-                        [name]):
+                    if (name != "secret"
+                        and (value !=
+                             old_client_settings[client_name][name])):
                         client[name] = value
                 except KeyError:
                     pass
@@ -2606,34 +2651,34 @@
                     if not client["last_checked_ok"]:
                         logger.warning(
                             "disabling client {} - Client never "
-                            "performed a successful checker"
-                            .format(client_name))
+                            "performed a successful checker".format(
+                                client_name))
                         client["enabled"] = False
                     elif client["last_checker_status"] != 0:
                         logger.warning(
                             "disabling client {} - Client last"
-                            " checker failed with error code {}"
-                            .format(client_name,
-                                    client["last_checker_status"]))
+                            " checker failed with error code"
+                            " {}".format(
+                                client_name,
+                                client["last_checker_status"]))
                         client["enabled"] = False
                     else:
-                        client["expires"] = (datetime.datetime
-                                             .utcnow()
-                                             + client["timeout"])
+                        client["expires"] = (
+                            datetime.datetime.utcnow()
+                            + client["timeout"])
                         logger.debug("Last checker succeeded,"
-                                     " keeping {} enabled"
-                                     .format(client_name))
+                                     " keeping {} enabled".format(
+                                         client_name))
             try:
-                client["secret"] = (
-                    pgp.decrypt(client["encrypted_secret"],
-                                client_settings[client_name]
-                                ["secret"]))
+                client["secret"] = pgp.decrypt(
+                    client["encrypted_secret"],
+                    client_settings[client_name]["secret"])
             except PGPError:
                 # If decryption fails, we use secret from new settings
-                logger.debug("Failed to decrypt {} old secret"
-                             .format(client_name))
-                client["secret"] = (
-                    client_settings[client_name]["secret"])
+                logger.debug("Failed to decrypt {} old secret".format(
+                    client_name))
+                client["secret"] = (client_settings[client_name]
+                                    ["secret"])
     
     # Add/remove clients based on new changes made to config
     for client_name in (set(old_client_settings)
@@ -2646,7 +2691,8 @@
     # Create all client objects
     for client_name, client in clients_data.items():
         tcp_server.clients[client_name] = client_class(
-            name = client_name, settings = client,
+            name = client_name,
+            settings = client,
             server_settings = server_settings)
     
     if not tcp_server.clients:
@@ -2657,7 +2703,7 @@
             try:
                 with pidfile:
                     pid = os.getpid()
-                    pidfile.write(str(pid) + "\n".encode("utf-8"))
+                    pidfile.write("{}\n".format(pid).encode("utf-8"))
             except IOError:
                 logger.error("Could not write to file %r with PID %d",
                              pidfilename, pid)
@@ -2668,19 +2714,22 @@
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
     if use_dbus:
-        @alternate_dbus_interfaces({"se.recompile.Mandos":
-                                        "se.bsnet.fukt.Mandos"})
+        
+        @alternate_dbus_interfaces(
+            { "se.recompile.Mandos": "se.bsnet.fukt.Mandos" })
         class MandosDBusService(DBusObjectWithProperties):
             """A D-Bus proxy object"""
+            
             def __init__(self):
                 dbus.service.Object.__init__(self, bus, "/")
+            
             _interface = "se.recompile.Mandos"
             
             @dbus_interface_annotations(_interface)
             def _foo(self):
-                return { "org.freedesktop.DBus.Property"
-                         ".EmitsChangedSignal":
-                             "false"}
+                return {
+                    "org.freedesktop.DBus.Property.EmitsChangedSignal":
+                    "false" }
             
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
@@ -2700,8 +2749,7 @@
             @dbus.service.method(_interface, out_signature="ao")
             def GetAllClients(self):
                 "D-Bus method"
-                return dbus.Array(c.dbus_object_path
-                                  for c in
+                return dbus.Array(c.dbus_object_path for c in
                                   tcp_server.clients.itervalues())
             
             @dbus.service.method(_interface,
@@ -2709,8 +2757,8 @@
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    ((c.dbus_object_path, c.GetAll(""))
-                     for c in tcp_server.clients.itervalues()),
+                    { c.dbus_object_path: c.GetAll("")
+                      for c in tcp_server.clients.itervalues() },
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
@@ -2756,8 +2804,8 @@
                 # + secret.
                 exclude = { "bus", "changedstate", "secret",
                             "checker", "server_settings" }
-                for name, typ in (inspect.getmembers
-                                  (dbus.service.Object)):
+                for name, typ in inspect.getmembers(dbus.service
+                                                    .Object):
                     exclude.add(name)
                 
                 client_dict["encrypted_secret"] = (client
@@ -2770,12 +2818,14 @@
                 del client_settings[client.name]["secret"]
         
         try:
-            with (tempfile.NamedTemporaryFile
-                  (mode='wb', suffix=".pickle", prefix='clients-',
-                   dir=os.path.dirname(stored_state_path),
-                   delete=False)) as stored_state:
+            with tempfile.NamedTemporaryFile(
+                    mode='wb',
+                    suffix=".pickle",
+                    prefix='clients-',
+                    dir=os.path.dirname(stored_state_path),
+                    delete=False) as stored_state:
                 pickle.dump((clients, client_settings), stored_state)
-                tempname=stored_state.name
+                tempname = stored_state.name
             os.rename(tempname, stored_state_path)
         except (IOError, OSError) as e:
             if not debug:
@@ -2800,9 +2850,8 @@
             client.disable(quiet=True)
             if use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client
-                                                  .dbus_object_path,
-                                                  client.name)
+                mandos_dbus_service.ClientRemoved(
+                    client.dbus_object_path, client.name)
         client_settings.clear()
     
     atexit.register(cleanup)
@@ -2861,5 +2910,6 @@
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
+
 if __name__ == '__main__':
     main()

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-07-25 23:42:53 +0000
+++ mandos-ctl	2015-04-02 21:56:15 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2015 Teddy Hogeborn
+# Copyright © 2008-2015 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -64,24 +64,24 @@
     "ApprovalDelay": "Approval Delay",
     "ApprovalDuration": "Approval Duration",
     "Checker": "Checker",
-    "ExtendedTimeout" : "Extended Timeout"
-    }
+    "ExtendedTimeout": "Extended Timeout"
+}
 defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
 domain = "se.recompile"
 busname = domain + ".Mandos"
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.7"
+version = "1.6.9"
+
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
-            .format(days = "{}T".format(td.days) if td.days else "",
-                    hours = td.seconds // 3600,
-                    minutes = (td.seconds % 3600) // 60,
-                    seconds = td.seconds % 60,
-                    ))
+    return ("{days}{hours:02}:{minutes:02}:{seconds:02}".format(
+        days = "{}T".format(td.days) if td.days else "",
+        hours = td.seconds // 3600,
+        minutes = (td.seconds % 3600) // 60,
+        seconds = td.seconds % 60))
 
 
 def rfc3339_duration_to_delta(duration):
@@ -125,7 +125,7 @@
     token_end = Token(re.compile(r"$"), None, frozenset())
     token_second = Token(re.compile(r"(\d+)S"),
                          datetime.timedelta(seconds=1),
-                         frozenset((token_end,)))
+                         frozenset((token_end, )))
     token_minute = Token(re.compile(r"(\d+)M"),
                          datetime.timedelta(minutes=1),
                          frozenset((token_second, token_end)))
@@ -147,7 +147,7 @@
                        frozenset((token_month, token_end)))
     token_week = Token(re.compile(r"(\d+)W"),
                        datetime.timedelta(weeks=1),
-                       frozenset((token_end,)))
+                       frozenset((token_end, )))
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
@@ -155,7 +155,7 @@
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset((token_duration, )) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -223,6 +223,7 @@
             value += datetime.timedelta(0, 0, 0, int(num))
     return value
 
+
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
@@ -234,19 +235,18 @@
     
     # Create format string to print table rows
     format_string = " ".join("{{{key}:{width}}}".format(
-            width = max(len(tablewords[key]),
-                        max(len(valuetostring(client[key],
-                                              key))
-                            for client in
-                            clients)),
-            key = key) for key in keywords)
+        width = max(len(tablewords[key]),
+                    max(len(valuetostring(client[key], key))
+                        for client in clients)),
+        key = key)
+                             for key in keywords)
     # Print header line
     print(format_string.format(**tablewords))
     for client in clients:
-        print(format_string.format(**{ key:
-                                           valuetostring(client[key],
-                                                         key)
-                                       for key in keywords }))
+        print(format_string.format(**{
+            key: valuetostring(client[key], key)
+            for key in keywords }))
+
 
 def has_actions(options):
     return any((options.enable,
@@ -268,6 +268,7 @@
                 options.approve,
                 options.deny))
 
+
 def main():
     parser = argparse.ArgumentParser()
     parser.add_argument("--version", action="version",
@@ -338,8 +339,7 @@
         bus = dbus.SystemBus()
         mandos_dbus_objc = bus.get_object(busname, server_path)
     except dbus.exceptions.DBusException:
-        print("Could not connect to Mandos server",
-              file=sys.stderr)
+        print("Could not connect to Mandos server", file=sys.stderr)
         sys.exit(1)
     
     mandos_serv = dbus.Interface(mandos_dbus_objc,
@@ -382,11 +382,10 @@
     
     if not has_actions(options) and clients:
         if options.verbose:
-            keywords = ("Name", "Enabled", "Timeout",
-                        "LastCheckedOK", "Created", "Interval",
-                        "Host", "Fingerprint", "CheckerRunning",
-                        "LastEnabled", "ApprovalPending",
-                        "ApprovedByDefault",
+            keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
+                        "Created", "Interval", "Host", "Fingerprint",
+                        "CheckerRunning", "LastEnabled",
+                        "ApprovalPending", "ApprovedByDefault",
                         "LastApprovalRequest", "ApprovalDelay",
                         "ApprovalDuration", "Checker",
                         "ExtendedTimeout")
@@ -397,16 +396,19 @@
     else:
         # Process each client in the list by all selected options
         for client in clients:
+            
             def set_client_prop(prop, value):
                 """Set a Client D-Bus property"""
                 client.Set(client_interface, prop, value,
                            dbus_interface=dbus.PROPERTIES_IFACE)
+            
             def set_client_prop_ms(prop, value):
                 """Set a Client D-Bus property, converted
                 from a string to milliseconds."""
                 set_client_prop(prop,
                                 string_to_delta(value).total_seconds()
                                 * 1000)
+            
             if options.remove:
                 mandos_serv.RemoveClient(client.__dbus_object_path__)
             if options.enable:
@@ -456,5 +458,6 @@
                 client.Approve(dbus.Boolean(False),
                                dbus_interface=client_interface)
 
+
 if __name__ == "__main__":
     main()

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-07-17 03:24:57 +0000
+++ mandos-keygen	2015-05-23 10:41:35 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2015 Teddy Hogeborn
+# Copyright © 2008-2015 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.7"
+VERSION="1.6.9"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA
@@ -47,7 +47,7 @@
     --name "$0" -- "$@"`
 
 help(){
-basename="`basename $0`"
+basename="`basename "$0"`"
 cat <<EOF
 Usage: $basename [ -v | --version ]
        $basename [ -h | --help ]
@@ -113,7 +113,7 @@
     esac
 done
 if [ "$#" -gt 0 ]; then
-    echo "Unknown arguments: '$@'" >&2
+    echo "Unknown arguments: '$*'" >&2
     exit 1
 fi
 
@@ -285,13 +285,19 @@
     esac
     
     if [ $SSH -eq 1 ]; then
-	set +e
-	ssh_fingerprint="`ssh-keyscan localhost 2>/dev/null`"
-	if [ $? -ne 0 ]; then
-	    ssh_fingerprint=""
-	fi
-	set -e
-	ssh_fingerprint="${ssh_fingerprint#localhost }"
+	for ssh_keytype in ed25519 rsa; do
+	    set +e
+	    ssh_fingerprint="`ssh-keyscan -t $ssh_keytype localhost 2>/dev/null`"
+	    set -e
+	    if [ $? -ne 0 ]; then
+		ssh_fingerprint=""
+		continue
+	    fi
+	    if [ -n "$ssh_fingerprint" ]; then
+		ssh_fingerprint="${ssh_fingerprint#localhost }"
+		break
+	    fi
+	done
     fi
     
     # Import key into temporary key rings
@@ -304,7 +310,7 @@
     
     # Get fingerprint of key
     FINGERPRINT="`gpg --quiet --batch --no-tty --no-options \
-	--enable-dsa2 --homedir \"$RINGDIR\" --trust-model always \
+	--enable-dsa2 --homedir "$RINGDIR" --trust-model always \
 	--fingerprint --with-colons \
 	| sed --quiet \
 	--expression='/^fpr:/{s/^fpr:.*:\\([0-9A-Z]*\\):\$/\\1/p;q}'`"
@@ -363,7 +369,7 @@
 	    }
 	}' < "$SECFILE"
     if [ -n "$ssh_fingerprint" ]; then
-	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp="%%(host)s %(ssh_fingerprint)s"'
+	echo 'checker = ssh-keyscan -t '"$ssh_keytype"' %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp=%%(host)s" %(ssh_fingerprint)s"'
 	echo "ssh_fingerprint = ${ssh_fingerprint}"
     fi
 fi

=== modified file 'mandos-monitor'
--- mandos-monitor	2014-07-25 23:42:53 +0000
+++ mandos-monitor	2014-10-05 20:08:58 +0000
@@ -60,7 +60,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.7"
+version = "1.6.9"
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -87,9 +87,9 @@
         self.proxy = proxy_object # Mandos Client proxy object
         self.properties = dict() if properties is None else properties
         self.property_changed_match = (
-            self.proxy.connect_to_signal("PropertyChanged",
-                                         self._property_changed,
-                                         client_interface,
+            self.proxy.connect_to_signal("PropertiesChanged",
+                                         self.properties_changed,
+                                         dbus.PROPERTIES_IFACE,
                                          byte_arrays=True))
         
         if properties is None:
@@ -100,16 +100,12 @@
         
         super(MandosClientPropertyCache, self).__init__(**kwargs)
     
-    def _property_changed(self, property, value):
-        """Helper which takes positional arguments"""
-        return self.property_changed(property=property, value=value)
-    
-    def property_changed(self, property=None, value=None):
-        """This is called whenever we get a PropertyChanged signal
-        It updates the changed property in the "properties" dict.
+    def properties_changed(self, interface, properties, invalidated):
+        """This is called whenever we get a PropertiesChanged signal
+        It updates the changed properties in the "properties" dict.
         """
         # Update properties dict with new value
-        self.properties[property] = value
+        self.properties.update(properties)
     
     def delete(self):
         self.property_changed_match.remove()
@@ -377,14 +373,15 @@
         else:
             return key
     
-    def property_changed(self, property=None, **kwargs):
-        """Call self.update() if old value is not new value.
+    def properties_changed(self, interface, properties, invalidated):
+        """Call self.update() if any properties changed.
         This overrides the method from MandosClientPropertyCache"""
-        property_name = str(property)
-        old_value = self.properties.get(property_name)
-        super(MandosClientWidget, self).property_changed(
-            property=property, **kwargs)
-        if self.properties.get(property_name) != old_value:
+        old_values = { key: self.properties.get(key)
+                       for key in properties.keys() }
+        super(MandosClientWidget, self).properties_changed(
+            interface, properties, invalidated)
+        if any(old_values[key] != self.properties.get(key)
+               for key in old_values):
             self.update()
 
 

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2014-06-15 02:48:49 +0000
+++ mandos-options.xml	2015-03-10 18:03:38 +0000
@@ -49,25 +49,28 @@
   <para id="priority_compat">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
     The default is <quote><literal
-    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:+SIGN-RSA-SHA224:</literal>
-    <literal>+SIGN-RSA-RMD160</literal></quote>.
+    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal>
+    <literal>:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160</literal></quote>.
     See <citerefentry><refentrytitle
     >gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.
     <emphasis>Warning</emphasis>: changing this may make the
     <acronym>TLS</acronym> handshake fail, making server-client
-    communication impossible.
+    communication impossible.  Changing this option may also make the
+    network traffic decryptable by an attacker.
   </para>
   
   <para id="priority">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
     The default is <quote><literal
-    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP</literal></quote>.  See
-    <citerefentry><refentrytitle >gnutls_priority_init</refentrytitle>
+    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal></quote>.
+    See <citerefentry><refentrytitle
+    >gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.
     <emphasis>Warning</emphasis>: changing this may make the
     <acronym>TLS</acronym> handshake fail, making server-client
-    communication impossible.
+    communication impossible.  Changing this option may also make the
+    network traffic decryptable by an attacker.
   </para>
   
   <para id="servicename">

=== modified file 'mandos.conf'
--- mandos.conf	2014-06-15 02:48:49 +0000
+++ mandos.conf	2015-04-02 18:59:29 +0000
@@ -23,7 +23,7 @@
 ;debug = False
 
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
-;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160
+;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160
 
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2013-10-24 20:21:45 +0000
+++ mandos.conf.xml	2015-04-02 18:59:29 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2013-10-23">
+<!ENTITY TIMESTAMP "2015-04-02">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -223,8 +223,8 @@
 interface = eth0
 address = fe80::aede:48ff:fe71:f6f2
 port = 1025
-debug = true
-priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
+debug = True
+priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA
 servicename = Daena
 use_dbus = False
 use_ipv6 = True

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-07-17 03:24:57 +0000
+++ mandos.lsm	2014-10-05 20:08:58 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.6.7
-Entered-date:	2014-07-17
+Version:	1.6.9
+Entered-date:	2014-10-05
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.7.orig.tar.gz
+		161K mandos_1.6.9.orig.tar.gz
 Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.7.orig.tar.gz
+		161K mandos_1.6.9.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other

=== modified file 'mandos.service'
--- mandos.service	2013-12-31 16:02:18 +0000
+++ mandos.service	2014-10-05 19:39:25 +0000
@@ -1,12 +1,13 @@
 [Unit]
 Description=Server of encrypted passwords to Mandos clients
+Documentation=man:intro(8mandos) man:mandos(8)
 
 [Service]
 Type=simple
 ## Type=dbus is not appropriate, because Mandos also needs to announce
 ## its ZeroConf service and be reachable on the network.
 #Type=dbus
-BusName=se.recompile.Mandos
+#BusName=se.recompile.Mandos
 # If you add --no-dbus, also comment out BusName above, and vice versa
 ExecStart=/usr/sbin/mandos --foreground
 Restart=always

=== modified file 'mandos.xml'
--- mandos.xml	2014-06-15 02:48:49 +0000
+++ mandos.xml	2015-01-25 00:02:51 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2014-06-15">
+<!ENTITY TIMESTAMP "2015-01-25">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -707,8 +707,7 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  <ulink url="http://www.gnu.org/software/gnutls/"
-	  >GnuTLS</ulink>
+	  <ulink url="http://gnutls.org/">GnuTLS</ulink>
 	</term>
       <listitem>
 	<para>
@@ -752,12 +751,12 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 4346: <citetitle>The Transport Layer Security (TLS)
-	  Protocol Version 1.1</citetitle>
+	  RFC 5246: <citetitle>The Transport Layer Security (TLS)
+	  Protocol Version 1.2</citetitle>
 	</term>
       <listitem>
 	<para>
-	  TLS 1.1 is the protocol implemented by GnuTLS.
+	  TLS 1.2 is the protocol implemented by GnuTLS.
 	</para>
       </listitem>
       </varlistentry>
@@ -773,8 +772,8 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 5081: <citetitle>Using OpenPGP Keys for Transport Layer
-	  Security</citetitle>
+	  RFC 6091: <citetitle>Using OpenPGP Keys for Transport Layer
+	  Security (TLS) Authentication</citetitle>
 	</term>
       <listitem>
 	<para>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2014-03-29 02:38:15 +0000
+++ plugins.d/askpass-fifo.c	2014-08-09 23:37:07 +0000
@@ -23,7 +23,7 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-#include <sys/types.h>		/* ssize_t */
+#include <sys/types.h>		/* uid_t, gid_t, ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
 #include <iso646.h>		/* and */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
@@ -44,6 +44,8 @@
 #include <string.h> 		/* strerror() */
 #include <stdarg.h>		/* va_list, va_start(), ... */
 
+uid_t uid = 65534;
+gid_t gid = 65534;
 
 /* Function to use when printing errors */
 __attribute__((format (gnu_printf, 3, 4)))
@@ -74,6 +76,9 @@
   int ret = 0;
   ssize_t sret;
   
+  uid = getuid();
+  gid = getgid();
+  
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
@@ -119,6 +124,16 @@
     }
   }
   
+  /* Lower group privileges  */
+  if(setgid(gid) == -1){
+    error_plus(0, errno, "setgid");
+  }
+  
+  /* Lower user privileges */
+  if(setuid(uid) == -1){
+    error_plus(0, errno, "setuid");
+  }
+  
   /* Read from FIFO */
   char *buf = NULL;
   size_t buf_len = 0;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2014-07-15 23:52:00 +0000
+++ plugins.d/mandos-client.c	2015-03-10 18:52:09 +0000
@@ -493,12 +493,17 @@
   return plaintext_length;
 }
 
+__attribute__((warn_unused_result, const))
+static const char *safe_string(const char *str){
+  if(str == NULL)
+    return "(unknown)";
+  return str;
+}
+
 __attribute__((warn_unused_result))
 static const char *safer_gnutls_strerror(int value){
   const char *ret = gnutls_strerror(value);
-  if(ret == NULL)
-    ret = "(unknown)";
-  return ret;
+  return safe_string(ret);
 }
 
 /* GnuTLS log function callback */
@@ -513,6 +518,7 @@
 			      const char *seckeyfilename,
 			      mandos_context *mc){
   int ret;
+  unsigned int uret;
   
   if(debug){
     fprintf_plus(stderr, "Initializing GnuTLS\n");
@@ -569,10 +575,111 @@
 		 safer_gnutls_strerror(ret));
     goto globalfail;
   }
+  if(mc->dh_bits == 0){
+    /* Find out the optimal number of DH bits */
+    /* Try to read the private key file */
+    gnutls_datum_t buffer = { .data = NULL, .size = 0 };
+    {
+      int secfile = open(seckeyfilename, O_RDONLY);
+      size_t buffer_capacity = 0;
+      while(true){
+	buffer_capacity = incbuffer((char **)&buffer.data,
+				    (size_t)buffer.size,
+				    (size_t)buffer_capacity);
+	if(buffer_capacity == 0){
+	  perror_plus("incbuffer");
+	  free(buffer.data);
+	  buffer.data = NULL;
+	  break;
+	}
+	ssize_t bytes_read = read(secfile, buffer.data + buffer.size,
+				  BUFFER_SIZE);
+	/* EOF */
+	if(bytes_read == 0){
+	  break;
+	}
+	/* check bytes_read for failure */
+	if(bytes_read < 0){
+	  perror_plus("read");
+	  free(buffer.data);
+	  buffer.data = NULL;
+	  break;
+	}
+	buffer.size += (unsigned int)bytes_read;
+      }
+      close(secfile);
+    }
+    /* If successful, use buffer to parse private key */
+    gnutls_sec_param_t sec_param = GNUTLS_SEC_PARAM_ULTRA;
+    if(buffer.data != NULL){
+      {
+	gnutls_openpgp_privkey_t privkey = NULL;
+	ret = gnutls_openpgp_privkey_init(&privkey);
+	if(ret != GNUTLS_E_SUCCESS){
+	  fprintf_plus(stderr, "Error initializing OpenPGP key"
+		       " structure: %s", safer_gnutls_strerror(ret));
+	  free(buffer.data);
+	  buffer.data = NULL;
+	} else {
+	  ret = gnutls_openpgp_privkey_import(privkey, &buffer,
+					    GNUTLS_OPENPGP_FMT_BASE64,
+					      "", 0);
+	  if(ret != GNUTLS_E_SUCCESS){
+	    fprintf_plus(stderr, "Error importing OpenPGP key : %s",
+			 safer_gnutls_strerror(ret));
+	    privkey = NULL;
+	  }
+	  free(buffer.data);
+	  buffer.data = NULL;
+	  if(privkey != NULL){
+	    /* Use private key to suggest an appropriate sec_param */
+	    sec_param = gnutls_openpgp_privkey_sec_param(privkey);
+	    gnutls_openpgp_privkey_deinit(privkey);
+	    if(debug){
+	      fprintf_plus(stderr, "This OpenPGP key implies using a"
+			   " GnuTLS security parameter \"%s\".\n",
+			   safe_string(gnutls_sec_param_get_name
+				       (sec_param)));
+	    }
+	  }
+	}
+      }
+      if(sec_param == GNUTLS_SEC_PARAM_UNKNOWN){
+	/* Err on the side of caution */
+	sec_param = GNUTLS_SEC_PARAM_ULTRA;
+	if(debug){
+	  fprintf_plus(stderr, "Falling back to security parameter"
+		       " \"%s\"\n",
+		       safe_string(gnutls_sec_param_get_name
+				   (sec_param)));
+	}
+      }
+    }
+    uret = gnutls_sec_param_to_pk_bits(GNUTLS_PK_DH, sec_param);
+    if(uret != 0){
+      mc->dh_bits = uret;
+      if(debug){
+	fprintf_plus(stderr, "A \"%s\" GnuTLS security parameter"
+		     " implies %u DH bits; using that.\n",
+		     safe_string(gnutls_sec_param_get_name
+				 (sec_param)),
+		     mc->dh_bits);
+      }
+    } else {
+      fprintf_plus(stderr, "Failed to get implied number of DH"
+		   " bits for security parameter \"%s\"): %s\n",
+		   safe_string(gnutls_sec_param_get_name(sec_param)),
+		   safer_gnutls_strerror(ret));
+      goto globalfail;
+    }
+  } else if(debug){
+    fprintf_plus(stderr, "DH bits explicitly set to %u\n",
+		 mc->dh_bits);
+  }
   ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS prime generation: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf_plus(stderr, "Error in GnuTLS prime generation (%u bits):"
+		 " %s\n", mc->dh_bits, safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
@@ -1650,6 +1757,11 @@
 	_exit(EXIT_FAILURE);
       }
     } else {
+      if(hook_pid == -1){
+	perror_plus("fork");
+	free(direntry);
+	continue;
+      }
       int status;
       if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
 	perror_plus("waitpid");
@@ -1895,9 +2007,9 @@
 }
 
 int main(int argc, char *argv[]){
-  mandos_context mc = { .server = NULL, .dh_bits = 1024,
+  mandos_context mc = { .server = NULL, .dh_bits = 0,
 			.priority = "SECURE256:!CTYPE-X.509:"
-			"+CTYPE-OPENPGP", .current_server = NULL,
+			"+CTYPE-OPENPGP:!RSA", .current_server = NULL,
 			.interfaces = NULL, .interfaces_size = 0 };
   AvahiSServiceBrowser *sb = NULL;
   error_t ret_errno;

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2014-06-22 02:19:30 +0000
+++ plugins.d/mandos-client.xml	2015-03-10 18:52:09 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2015-03-08">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -311,7 +311,8 @@
 	<listitem>
 	  <para>
 	    Sets the number of bits to use for the prime number in the
-	    TLS Diffie-Hellman key exchange.  Default is 1024.
+	    TLS Diffie-Hellman key exchange.  The default value is
+	    selected automatically based on the OpenPGP key.
 	  </para>
 	</listitem>
       </varlistentry>

